package cn.ibizlab.core.util.config;

import com.alibaba.fastjson.JSON;
import com.alibaba.rocketmq.client.consumer.DefaultMQPushConsumer;
import com.alibaba.rocketmq.client.consumer.listener.ConsumeConcurrentlyContext;
import com.alibaba.rocketmq.client.consumer.listener.ConsumeConcurrentlyStatus;
import com.alibaba.rocketmq.client.consumer.listener.MessageListenerConcurrently;
import com.alibaba.rocketmq.client.producer.DefaultMQProducer;
import com.alibaba.rocketmq.common.message.MessageExt;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Lazy;
import java.util.List;

@Slf4j
@Configuration
public class RocketMQConfig {


    @Autowired
    @Lazy
    cn.ibizlab.core.uaa.service.ISysUserService SysUserService;

    @Bean("SysUserdeleteSysUserconsumer")
    public DefaultMQPushConsumer sysUserdeleteSysUserconsumer(){
        DefaultMQPushConsumer consumer = null;
        try {
            consumer = new DefaultMQPushConsumer();
            consumer.setNamesrvAddr("127.0.0.1:9876");
            consumer.setInstanceName("rmq-instance");
            consumer.subscribe("deleteSysUser", "deleteSysUser");
            consumer.registerMessageListener(new MessageListenerConcurrently() {
                public ConsumeConcurrentlyStatus consumeMessage(
                        List<MessageExt> msgs, ConsumeConcurrentlyContext context) {
                    for (MessageExt msg : msgs) {
                        cn.ibizlab.core.uaa.domain.SysUser domain = JSON.parseObject(new String(msg.getBody()),cn.ibizlab.core.uaa.domain.SysUser.class);
                        SysUserService.remove(domain);
                    }
                    return ConsumeConcurrentlyStatus.CONSUME_SUCCESS;
                }
            });
            consumer.start();
        }catch (Exception e){
            log.error("初始化消息接收对象异常!");
        }
        return consumer;
    }
    @Autowired
    @Lazy
    cn.ibizlab.core.uaa.service.ISysUserService SysUserService;

    @Bean("SysUsersaveSysUserconsumer")
    public DefaultMQPushConsumer sysUsersaveSysUserconsumer(){
        DefaultMQPushConsumer consumer = null;
        try {
            consumer = new DefaultMQPushConsumer();
            consumer.setNamesrvAddr("127.0.0.1:9876");
            consumer.setInstanceName("rmq-instance");
            consumer.subscribe("saveSysUser", "saveSysUser");
            consumer.registerMessageListener(new MessageListenerConcurrently() {
                public ConsumeConcurrentlyStatus consumeMessage(
                        List<MessageExt> msgs, ConsumeConcurrentlyContext context) {
                    for (MessageExt msg : msgs) {
                        cn.ibizlab.core.uaa.domain.SysUser domain = JSON.parseObject(new String(msg.getBody()),cn.ibizlab.core.uaa.domain.SysUser.class);
                        SysUserService.saveSysUser(domain);
                    }
                    return ConsumeConcurrentlyStatus.CONSUME_SUCCESS;
                }
            });
            consumer.start();
        }catch (Exception e){
            log.error("初始化消息接收对象异常!");
        }
        return consumer;
    }
}
